# Some portitions: example titled rectangle.rb by @Last Software, Inc. 
#  
# Name:           Srub
# Description:    Create a box of logs in center of scene 
# Usage:          Just put date in inputbox
# Date:           
# Type:           Srub
# Revised:        
#------------------------------------------------------------------------------------------------

require 'sketchup.rb'
require 'parametric.rb'

# set to true for debug output to console
$VERBOSE = true



class Srub < Parametric

def create_entities(data, container)
    widthC = data["r"]/2 .to_l
    k = data["k"].to_l
    h = data["h"].to_l
    n = data["seg"]
            
    pts = [-h/2,k/2-widthC*3,widthC]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = -h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    a = (widthC*2)-(widthC*2)/8
    pts = [-h/2,k/2-widthC*3,widthC+a]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    b = ((widthC*2)-(widthC*2)/8)*2
    pts = [-h/2,k/2-widthC*3,widthC+b]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    d = ((widthC*2)-(widthC*2)/8)*3
    pts = [-h/2,k/2-widthC*3,widthC+d]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    e = ((widthC*2)-(widthC*2)/8)*4
    pts = [-h/2,k/2-widthC*3,widthC+e]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    f = ((widthC*2)-(widthC*2)/8)*5
    pts = [-h/2,k/2-widthC*3,widthC+f]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    i = ((widthC*2)-(widthC*2)/8)*6
    pts = [-h/2,k/2-widthC*3,widthC+i]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    j = ((widthC*2)-(widthC*2)/8)*7
    pts = [-h/2,k/2-widthC*3,widthC+j]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    l = ((widthC*2)-(widthC*2)/8)*8
    pts = [-h/2,k/2-widthC*3,widthC+l]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    v = ((widthC*2)-(widthC*2)/8)*9
    pts = [-h/2,k/2-widthC*3,widthC+v]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    u = ((widthC*2)-(widthC*2)/8)*10
    pts = [-h/2,k/2-widthC*3,widthC+u]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    o = ((widthC*2)-(widthC*2)/8)*11
    pts = [-h/2,k/2-widthC*3,widthC+o]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    c = ((widthC*2)-(widthC*2)/8)*12
    pts = [-h/2,k/2-widthC*3,widthC+c]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    g = ((widthC*2)-(widthC*2)/8)*13
    pts = [-h/2,k/2-widthC*3,widthC+g]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    #------------------------------------------------------------------------------------------------
    pts = [-h/2+widthC*3,k/2,widthC*2]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = -k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
        a = (widthC*2)-(widthC*2)/8
    pts = [-h/2+widthC*3,k/2,widthC*2+a]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    b = ((widthC*2)-(widthC*2)/8)*2
    pts = [-h/2+widthC*3,k/2,widthC*2+b]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    d = ((widthC*2)-(widthC*2)/8)*3
    pts = [-h/2+widthC*3,k/2,widthC*2+d]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    e = ((widthC*2)-(widthC*2)/8)*4
    pts = [-h/2+widthC*3,k/2,widthC*2+e]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    f = ((widthC*2)-(widthC*2)/8)*5
    pts = [-h/2+widthC*3,k/2,widthC*2+f]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    i = ((widthC*2)-(widthC*2)/8)*6
    pts = [-h/2+widthC*3,k/2,widthC*2+i]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    j = ((widthC*2)-(widthC*2)/8)*7
    pts = [-h/2+widthC*3,k/2,widthC*2+j]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    l = ((widthC*2)-(widthC*2)/8)*8
    pts = [-h/2+widthC*3,k/2,widthC*2+l]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    v = ((widthC*2)-(widthC*2)/8)*9
    pts = [-h/2+widthC*3,k/2,widthC*2+v]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    u = ((widthC*2)-(widthC*2)/8)*10
    pts = [-h/2+widthC*3,k/2,widthC*2+u]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    o = ((widthC*2)-(widthC*2)/8)*11
    pts = [-h/2+widthC*3,k/2,widthC*2+o]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    c = ((widthC*2)-(widthC*2)/8)*12
    pts = [-h/2+widthC*3,k/2,widthC*2+c]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    g = ((widthC*2)-(widthC*2)/8)*13
    pts = [-h/2+widthC*3,k/2,widthC*2+g]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    #------------------------------------------------------------------------------------------------
    pts = [h/2-widthC*3,k/2,widthC*2]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = -k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    a = (widthC*2)-(widthC*2)/8
    pts = [h/2-widthC*3,k/2,widthC*2+a]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    b = ((widthC*2)-(widthC*2)/8)*2
    pts = [h/2-widthC*3,k/2,widthC*2+b]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    d = ((widthC*2)-(widthC*2)/8)*3
    pts = [h/2-widthC*3,k/2,widthC*2+d]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    e = ((widthC*2)-(widthC*2)/8)*4
    pts = [h/2-widthC*3,k/2,widthC*2+e]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    f = ((widthC*2)-(widthC*2)/8)*5
    pts = [h/2-widthC*3,k/2,widthC*2+f]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    i = ((widthC*2)-(widthC*2)/8)*6
    pts = [h/2-widthC*3,k/2,widthC*2+i]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    j = ((widthC*2)-(widthC*2)/8)*7
    pts = [h/2-widthC*3,k/2,widthC*2+j]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    l = ((widthC*2)-(widthC*2)/8)*8
    pts = [h/2-widthC*3,k/2,widthC*2+l]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    v = ((widthC*2)-(widthC*2)/8)*9
    pts = [h/2-widthC*3,k/2,widthC*2+v]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    u = ((widthC*2)-(widthC*2)/8)*10
    pts = [h/2-widthC*3,k/2,widthC*2+u]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    o = ((widthC*2)-(widthC*2)/8)*11
    pts = [h/2-widthC*3,k/2,widthC*2+o]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    c = ((widthC*2)-(widthC*2)/8)*12
    pts = [h/2-widthC*3,k/2,widthC*2+c]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    g = ((widthC*2)-(widthC*2)/8)*13
    pts = [h/2-widthC*3,k/2,widthC*2+g]
    circle = container.add_circle pts, Y_AXIS, widthC, n
    base = container.add_face circle
    k = k if base.normal.dot(X_AXIS) < 0.0
    base.pushpull -k
    #------------------------------------------------------------------------------------------------
    pts = [-h/2,-(k/2-widthC*3),widthC]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = -h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
        a = (widthC*2)-(widthC*2)/8
    pts = [-h/2,-(k/2-widthC*3),widthC+a]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    b = ((widthC*2)-(widthC*2)/8)*2
    pts = [-h/2,-(k/2-widthC*3),widthC+b]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    d = ((widthC*2)-(widthC*2)/8)*3
    pts = [-h/2,-(k/2-widthC*3),widthC+d]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    e = ((widthC*2)-(widthC*2)/8)*4
    pts = [-h/2,-(k/2-widthC*3),widthC+e]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    f = ((widthC*2)-(widthC*2)/8)*5
    pts = [-h/2,-(k/2-widthC*3),widthC+f]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    i = ((widthC*2)-(widthC*2)/8)*6
    pts = [-h/2,-(k/2-widthC*3),widthC+i]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    j = ((widthC*2)-(widthC*2)/8)*7
    pts = [-h/2,-(k/2-widthC*3),widthC+j]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    l = ((widthC*2)-(widthC*2)/8)*8
    pts = [-h/2,-(k/2-widthC*3),widthC+l]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    v = ((widthC*2)-(widthC*2)/8)*9
    pts = [-h/2,-(k/2-widthC*3),widthC+v]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    u = ((widthC*2)-(widthC*2)/8)*10
    pts = [-h/2,-(k/2-widthC*3),widthC+u]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    o = ((widthC*2)-(widthC*2)/8)*11
    pts = [-h/2,-(k/2-widthC*3),widthC+o]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    c = ((widthC*2)-(widthC*2)/8)*12
    pts = [-h/2,-(k/2-widthC*3),widthC+c]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h
    g = ((widthC*2)-(widthC*2)/8)*13
    pts = [-h/2,-(k/2-widthC*3),widthC+g]
    circle = container.add_circle pts, X_AXIS, widthC, n
    base = container.add_face circle
    h = h if base.normal.dot(X_AXIS) < 0.0
    base.pushpull h

end
def default_parameters
    defaults = {"k", 400.cm, "r", 23.cm, "h", 600.cm, "seg", 32}
    defaults
 end
def translate_key(key)
    prompt = key
    case( key )
        when "k"
            prompt = "Width:  "
        when "r"
            prompt = "Diametr:  "
        when "h"
            prompt = "Length: "
        when "seg"
            prompt = "Segments: "
    end
    prompt
  end
  
end

#=============================================================================
def Srub.select_tool
    Sketchup.active_model.select_tool Srub.new
end

if( not file_loaded?("Srub.rb") )
    UI.menu("Draw").add_item("Log-creator") { Srub.select_tool}   
   
end
#-----------------------------------------------------------------------------
file_loaded("Srub.rb")
